#ifndef AGDDBOOLEANSOLIDHH
#define AGDDBOOLEANSOLIDHH

namespace agdd {
  class BooleanSolid;
}

#include <string>
#include "ExpatInterface/Element.h"
#include "agddSolid.hh"
#include "agddHasTag.hh"
#include "agddSolidPosContainer.hh"

namespace agdd {

  class BooleanSolid : public Solid, public HasTag, public SolidPosContainer {
  public:
    explicit BooleanSolid(const string & tag) : 
      Solid(),
      HasTag(tag),
      SolidPosContainer()
      {
    };
  public:
    void doBooleanSolidThingsToThisElement(xml::Element * elt) {
      doSolidThingsToThisElement(elt);
    };
  };
}

#endif
