
#include <vector>
#include "agddSection.hh"
#include "agddVolume.hh"
#include "ExpatInterface/Element.h"

namespace agdd {

  Volume::Volume() : _sec(0) {};
  bool Volume::thisVolumeIsInSomeSection() const { // In the sense of section elements.
    return _sec?true:false;
  };
  void Volume::doVolumeThingsToThisElement(xml::Element * elt) {
    nameThisElement(elt);
  };
  void Volume::putThisVolumeElementIntoThisSection(xml::Element * elt, Section * sec) {
    assert(sec);
    assert(elt);
    assert(thisVolumeIsNotInSomeSection());
    sec->theElement()->addChild(elt);
    _sec=sec;
  };
  Section * Volume::getSection() {
    assert (thisVolumeIsInSomeSection());
    return _sec;
  };
} // end of agdd namespace

