#ifndef AGDDVOLUMEHH
#define AGDDVOLUMEHH

#include <vector>
#include "agddHasName.hh"
#include "agddSection.hh"
#include "ExpatInterface/Element.h"

namespace agdd {

  class Volume : public HasName {
  private:
    Section * _sec; // Section I have been inserted into (as an xml element).
  public:
    Volume();
    virtual void putMyselfIn(Section *) = 0;
    virtual ~Volume() {};
  protected:
    void doVolumeThingsToThisElement(xml::Element * elt) ;
    bool thisVolumeIsInSomeSection() const ;
    bool thisVolumeIsNotInSomeSection() const { return !thisVolumeIsInSomeSection(); } ;
  protected: // public:
    void putThisVolumeElementIntoThisSection(xml::Element * elt, Section * sec) ;
  protected:
    Section * getSection() ;
  };

} // end of agdd namespace

#endif
