#ifndef AGDDKNOWSDTDVERSIONHH
#define AGDDKNOWSDTDVERSIONHH

#include "ExpatInterface/Element.h"
#include "agddAttribute.hh"

namespace agdd {

  class KnowsDTDVersion {
  private:
    Attribute _dTDVersion;
  public:
    KnowsDTDVersion() : _dTDVersion ("DTD_version", Attribute::required) {
      _dTDVersion.setValue("v4");
    };
    void versionThisElement(xml::Element * elt) {
      _dTDVersion.addAttributeTo(elt);
    };
  };

} // end of agdd namespace

#endif
