
#include <string>
#include <strstream>
#include <iomanip>
#include "agddNumberString.hh"

const string makeNumberString(const unsigned int x) {
     ostrstream o;
     o 
       // << setprecision(10) 
       << setiosflags(ios::fixed)
       << x << ends;
     return o.str();
   };
const string makeNumberString(const unsigned int x, 
			      const unsigned int y) {
  return makeNumberString(x)+" "+makeNumberString(y);
};
const string makeNumberString(const unsigned int x, 
			      const unsigned int y, 
			      const unsigned int z) {
  return makeNumberString(x)+" "+makeNumberString(y,z);
}; 
const string makeNumberString(const unsigned int a, 
			      const unsigned int b, 
			      const unsigned int c, 
			      const unsigned int d) {
  return makeNumberString(a,b)+" "+makeNumberString(c,d);
}; 
const string makeNumberString(const unsigned int a, 
			      const unsigned int b, 
			      const unsigned int c, 
			      const unsigned int d, 
			      const unsigned int e) {
  return makeNumberString(a,b,c)+" "+makeNumberString(d,e);
};
const string makeNumberString(const int x) {
     ostrstream o;
     o 
       // << setprecision(10) 
       << setiosflags(ios::fixed)
       << x << ends;
     return o.str();
   };
const string makeNumberString(const int x, 
			      const int y) {
  return makeNumberString(x)+" "+makeNumberString(y);
};
const string makeNumberString(const int x, 
			      const int y, 
			      const int z) {
  return makeNumberString(x)+" "+makeNumberString(y,z);
}; 
const string makeNumberString(const int a, 
			      const int b, 
			      const int c, 
			      const int d) {
  return makeNumberString(a,b)+" "+makeNumberString(c,d);
}; 
const string makeNumberString(const int a, 
			      const int b, 
			      const int c, 
			      const int d, 
			      const int e) {
  return makeNumberString(a,b,c)+" "+makeNumberString(d,e);
};
const string makeNumberString(const double x) {
     ostrstream o;
     o << setprecision(10) 
       << setiosflags(ios::fixed)
       << x << ends;
     return o.str();
   };
const string makeNumberString(const double x, 
			      const double y) {
  return makeNumberString(x)+" "+makeNumberString(y);
};
const string makeNumberString(const double x, 
			      const double y, 
			      const double z) {
  return makeNumberString(x)+" "+makeNumberString(y,z);
}; 
const string makeNumberString(const double a, 
			      const double b, 
			      const double c, 
			      const double d) {
  return makeNumberString(a,b)+" "+makeNumberString(c,d);
}; 
const string makeNumberString(const double a, 
			      const double b, 
			      const double c, 
			      const double d, 
			      const double e) {
  return makeNumberString(a,b,c)+" "+makeNumberString(d,e);
};
