
#ifndef AGDDPOSHH
#define AGDDPOSHH

#include <string>
#include "agddHasTag.hh"
#include "agddPosContainer.hh"
#include "agddSolidPosContainer.hh"

namespace agdd {

  // This is an abstract base class for positions
  class Pos : public HasTag {
  public:
  protected:
    Pos(const string & tag) : 
      HasTag(tag) {
    }; 
  public:
    virtual void putMeInThisPosContainer(PosContainer * container) = 0;
    virtual void putMeInThisSolidPosContainer(SolidPosContainer * container) = 0;
    virtual ~Pos() {};
  };
}

#endif
