#ifndef PREXMLINTEGERHH
#define PREXMLINTEGERHH

#include <iostream>
#include "preXmlQuantity.hh"
#include "ExpatInterface/Element.h"

namespace preXml {

  class Integer : public Quantity {
  public:
    typedef long int IntegerType;
  private:
    IntegerType _value;
  public:
    void readFrom(const xml::Element & elt);
    void printMeNicelyTo(ostream & os) const;
    const IntegerType value() const { return _value;   };
    operator IntegerType() const { return _value; };
  };

} // end of preXml namespace

#endif
