#ifndef PREXMLQUANTITYHH
#define PREXMLQUANTITYHH

#include <vector>
#include <iostream>
#include "ExpatInterface/Element.h"

namespace preXml {

  class Quantity {
  public:  // sort access rights out later

    // Get from XML file:
    virtual void readFrom(const xml::Element & elt)  = 0;

    // Display in human readable way:
    virtual void printMeNicelyTo(ostream & os) const = 0;
  };

} // end of preXml namespace

ostream & operator << (ostream & os, const preXml::Quantity & quantity);

#endif
